<?php
// ***************************
// データベースクラス
// (このソースは UTF-8N)
//
// UTF-8 => SHIFT_JIS
// ***************************
class DB {
 
	public $connect;
	public $result;
 
// ***************************
// コンストラクタ
// ***************************
	function DB( $connect ) {

		$this->connect = odbc_connect($connect, "", "");

	}
 
// ***************************
// 接続解除
// ***************************
	function close( ) {

		odbc_close( $this->connect );

	}
 
// ***************************
// 単純クエリー( 実行 )
// ***************************
	function query( $sql_query ) {

		// SHIFT_JIS に変換
		$sql_query = mb_convert_encoding( $sql_query, "cp932", "utf-8" );

		$ret = @odbc_exec( $this->connect, $sql_query );
		return $ret;
	}
 
// ***************************
// フェッチ
// ***************************
	function fetch( $result=null ) {

		// 引数が無い場合は前回実行された 
		// $this->result を使用する
		if ( $result == null ) {
			$result = $this->result;
		}

		// SHIFT_JIS のデータのトラブル回避
		// ※ Invalid argument supplied for foreach()
		$error = error_reporting(E_ALL & ~E_WARNING);

		// SHIFT_JIS のデータ
		$ret1 = odbc_fetch_array( $result );
		// 空の配列
		$ret2 = array();

		// 数字をインデックスとする配列を作成する
		foreach ($ret1 as $key => $value) {
			// UTF-8 で使えるようにする
			$ret2[] = mb_convert_encoding( $value, "utf-8", "cp932" );
		}
		// 連想配列を作成する
		foreach ($ret1 as $key => $value) {
			// UTF-8 で使えるようにする
			$key = mb_convert_encoding( $key, "utf-8", "cp932" );
			$ret2[$key] = mb_convert_encoding( $value, "utf-8", "cp932" );
		}

		// 関数内での設定以前に戻す
		error_reporting($error);

		// 数字インデックスと文字列インデックスの連想配列
		return $ret2;
	}
 
// ***************************
// クエリーとフェッチ
// ***************************
	function query_ex( $sql_query='' ) {

		// 引数がある場合は、query and fetch
		if ( $sql_query != '' ) {
			$this->result = $this->query( $sql_query );
			if ( !$this->result ) {
				return false;
			}
			return $this->fetch( );
		}
		// 引数が無い場合は fetch のみ
		else {
			return $this->fetch( );
		}
 
	}

// ***************************
// 実行 : query と同じ
// ***************************
	function execute( $sql_exec ) {

		// SHIFT_JIS に変換
		$sql_exec = mb_convert_encoding( $sql_exec, "cp932", "utf-8" );

		$ret = odbc_exec( $this->connect, $sql_exec );
		return $ret;

	}
 
 
}
?>
