<?php
// ***************************
// このソースは UTF-8N
// ***************************
header( "Content-Type: text/plain; Charset=utf-8" );

// ***************************
// キャッシュを使用しない
// ***************************
header( "Expires: Thu, 19 Nov 1981 08:52:00 GMT" );
header( "Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0" );
header( "Pragma: no-cache" );

// ***************************
// データベースアクセスクラス
// ***************************
require_once("db.php");

// ***************************
// PHP 設定
// ***************************
mb_language( "ja" );
mb_internal_encoding("UTF-8");

// ***************************
// MS Acceess ファイル
// ***************************
$dbfile = "販売管理B.accdb";
//$dbfile = "販売管理B.mdb";

// ***************************
// ファイル名を SHIFT_JIS に変換
// ***************************
$dbfile = mb_convert_encoding( $dbfile, "cp932", "utf-8" );


// ***************************
// 接続文字列
// ODBC ドライバ名( 32ビット )
// のある場所 ▼
// HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\ODBC\ODBCINST.INI
// ***************************
$connect_string = "Provider=MSDASQL;";
$connect_string .= "Driver={Microsoft Access Driver (*.mdb, *.accdb)};";
$dbpath = realpath($dbfile);
$connect_string .= "dbq={$dbpath};";

// ***************************
// クラスのインスタンス
// ***************************
$db = new DB( $connect_string );
if ( $db->connect === false ) {
	print "接続に失敗しました : " . mb_convert_encoding( odbc_errormsg(), "utf-8", "cp932" );
	exit();
}

// ***************************
// 1) UTF-8 で SQL を作成
// ***************************
$query = <<<SQL
	select
		[社員マスタ].*,
		[社員マスタ].[社員コード] as scode
	from [社員マスタ]
	where [社員コード] in('0001','0002','0003')
SQL;

// ***************************
// データ全体用の配列
// ***************************
$json = array();

// ***************************
// クラスでクエリの実行
// ※ 初回
// ***************************
$column = $db->query_ex( $query );
if ( $column === false ) {
	print "SQLの実行に失敗しました : " . mb_convert_encoding( odbc_errormsg( $db->connect ), "utf-8", "cp932" );
	$db->close();
	exit();
}

// ***************************
// 全ての行を取得
// ***************************
while ( $column ) {

	// ***************************
	// 行単位で結果の連想配列をセット
	// ***************************
	$json['items'][] = $column;
	$column = $db->query_ex( );

};

// ***************************
// 接続解除
// ***************************
$db->close();

// ***************************
// php.exe の確認
// ***************************
if( PHP_INT_SIZE == 4 ) {
	print "PHPは 32ビットです\n";
}

// ***************************
// テストの為、見やすいオプション
// 1) 日本語をエスケープしない
// 2) 整形する
// ***************************
print json_encode( $json, JSON_UNESCAPED_UNICODE | JSON_PRETTY_PRINT);

?>
